// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// GetAzureInstanceTypesReader is a Reader for the GetAzureInstanceTypes structure.
type GetAzureInstanceTypesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAzureInstanceTypesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAzureInstanceTypesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetAzureInstanceTypesBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewGetAzureInstanceTypesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetAzureInstanceTypesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetAzureInstanceTypesOK creates a GetAzureInstanceTypesOK with default headers values
func NewGetAzureInstanceTypesOK() *GetAzureInstanceTypesOK {
	return &GetAzureInstanceTypesOK{}
}

/*GetAzureInstanceTypesOK handles this case with default header values.

Successful retrieval of Azure instance Types
*/
type GetAzureInstanceTypesOK struct {
	Payload []*models.AzureInstanceType
}

func (o *GetAzureInstanceTypesOK) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions/{location}/instanceTypes][%d] getAzureInstanceTypesOK  %+v", 200, o.Payload)
}

func (o *GetAzureInstanceTypesOK) GetPayload() []*models.AzureInstanceType {
	return o.Payload
}

func (o *GetAzureInstanceTypesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureInstanceTypesBadRequest creates a GetAzureInstanceTypesBadRequest with default headers values
func NewGetAzureInstanceTypesBadRequest() *GetAzureInstanceTypesBadRequest {
	return &GetAzureInstanceTypesBadRequest{}
}

/*GetAzureInstanceTypesBadRequest handles this case with default header values.

Bad Request
*/
type GetAzureInstanceTypesBadRequest struct {
	Payload *models.Error
}

func (o *GetAzureInstanceTypesBadRequest) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions/{location}/instanceTypes][%d] getAzureInstanceTypesBadRequest  %+v", 400, o.Payload)
}

func (o *GetAzureInstanceTypesBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureInstanceTypesBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureInstanceTypesUnauthorized creates a GetAzureInstanceTypesUnauthorized with default headers values
func NewGetAzureInstanceTypesUnauthorized() *GetAzureInstanceTypesUnauthorized {
	return &GetAzureInstanceTypesUnauthorized{}
}

/*GetAzureInstanceTypesUnauthorized handles this case with default header values.

Incorrect credentials
*/
type GetAzureInstanceTypesUnauthorized struct {
	Payload *models.Error
}

func (o *GetAzureInstanceTypesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions/{location}/instanceTypes][%d] getAzureInstanceTypesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAzureInstanceTypesUnauthorized) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureInstanceTypesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAzureInstanceTypesInternalServerError creates a GetAzureInstanceTypesInternalServerError with default headers values
func NewGetAzureInstanceTypesInternalServerError() *GetAzureInstanceTypesInternalServerError {
	return &GetAzureInstanceTypesInternalServerError{}
}

/*GetAzureInstanceTypesInternalServerError handles this case with default header values.

Internal server error
*/
type GetAzureInstanceTypesInternalServerError struct {
	Payload *models.Error
}

func (o *GetAzureInstanceTypesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /api/providers/azure/regions/{location}/instanceTypes][%d] getAzureInstanceTypesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAzureInstanceTypesInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *GetAzureInstanceTypesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
