// Code generated by go-swagger; DO NOT EDIT.

package aws

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// GetAWSOSImagesOKCode is the HTTP code returned for type GetAWSOSImagesOK
const GetAWSOSImagesOKCode int = 200

/*GetAWSOSImagesOK Successful retrieval of AWS supported os images

swagger:response getAWSOSImagesOK
*/
type GetAWSOSImagesOK struct {

	/*
	  In: Body
	*/
	Payload []*models.AWSVirtualMachine `json:"body,omitempty"`
}

// NewGetAWSOSImagesOK creates GetAWSOSImagesOK with default headers values
func NewGetAWSOSImagesOK() *GetAWSOSImagesOK {

	return &GetAWSOSImagesOK{}
}

// WithPayload adds the payload to the get a w s o s images o k response
func (o *GetAWSOSImagesOK) WithPayload(payload []*models.AWSVirtualMachine) *GetAWSOSImagesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get a w s o s images o k response
func (o *GetAWSOSImagesOK) SetPayload(payload []*models.AWSVirtualMachine) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAWSOSImagesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = make([]*models.AWSVirtualMachine, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetAWSOSImagesBadRequestCode is the HTTP code returned for type GetAWSOSImagesBadRequest
const GetAWSOSImagesBadRequestCode int = 400

/*GetAWSOSImagesBadRequest Bad request

swagger:response getAWSOSImagesBadRequest
*/
type GetAWSOSImagesBadRequest struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAWSOSImagesBadRequest creates GetAWSOSImagesBadRequest with default headers values
func NewGetAWSOSImagesBadRequest() *GetAWSOSImagesBadRequest {

	return &GetAWSOSImagesBadRequest{}
}

// WithPayload adds the payload to the get a w s o s images bad request response
func (o *GetAWSOSImagesBadRequest) WithPayload(payload *models.Error) *GetAWSOSImagesBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get a w s o s images bad request response
func (o *GetAWSOSImagesBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAWSOSImagesBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetAWSOSImagesUnauthorizedCode is the HTTP code returned for type GetAWSOSImagesUnauthorized
const GetAWSOSImagesUnauthorizedCode int = 401

/*GetAWSOSImagesUnauthorized Incorrect credentials

swagger:response getAWSOSImagesUnauthorized
*/
type GetAWSOSImagesUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAWSOSImagesUnauthorized creates GetAWSOSImagesUnauthorized with default headers values
func NewGetAWSOSImagesUnauthorized() *GetAWSOSImagesUnauthorized {

	return &GetAWSOSImagesUnauthorized{}
}

// WithPayload adds the payload to the get a w s o s images unauthorized response
func (o *GetAWSOSImagesUnauthorized) WithPayload(payload *models.Error) *GetAWSOSImagesUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get a w s o s images unauthorized response
func (o *GetAWSOSImagesUnauthorized) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAWSOSImagesUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetAWSOSImagesInternalServerErrorCode is the HTTP code returned for type GetAWSOSImagesInternalServerError
const GetAWSOSImagesInternalServerErrorCode int = 500

/*GetAWSOSImagesInternalServerError Internal server error

swagger:response getAWSOSImagesInternalServerError
*/
type GetAWSOSImagesInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAWSOSImagesInternalServerError creates GetAWSOSImagesInternalServerError with default headers values
func NewGetAWSOSImagesInternalServerError() *GetAWSOSImagesInternalServerError {

	return &GetAWSOSImagesInternalServerError{}
}

// WithPayload adds the payload to the get a w s o s images internal server error response
func (o *GetAWSOSImagesInternalServerError) WithPayload(payload *models.Error) *GetAWSOSImagesInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get a w s o s images internal server error response
func (o *GetAWSOSImagesInternalServerError) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAWSOSImagesInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
